<?php

/**
 * co_vigencia_futura actions.
 *
 * @package    contratacion
 * @subpackage co_vigencia_futura
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_vigencia_futuraActions extends sfQuery
{
    /*
    * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
    */
    protected $table_names = array(
        'CO_VIGENCIA_FUTURA','CO_ESTUDIOS_PREVIOS', 'CO_MODALIDAD_SEL'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_ESTUDIOS_PREVIOS' =>
        array(
            'id_estudios_previos' => 'CO_VIGENCIA_FUTURA'
        ),
        'CO_MODALIDAD_SEL' =>
        array(
            'id_modalidad_sel' => 'CO_ESTUDIOS_PREVIOS'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_VIGENCIA_FUTURA' =>
       array(
            'id_vigencia_futura' => 'id_vigencia_futura',
            'id_estudios_previos' => 'id_estudios_previos',
            'valor' => 'valor',
            'fecha_aprobacion' => 'fecha_aprobacion',
            'no_aprobacion' => 'no_aprobacion',
            'plazo_final' => 'plazo_final'
        ),
        'CO_MODALIDAD_SEL' =>
        array(
            'id_modalidad_sel' => 'id_modalidad_sel',
            'descripcion' => 'descripcion_modalidad'
        ),
        'CO_ESTUDIOS_PREVIOS' =>
        array(
            'no_proceso' => 'no_proceso',
            'id_anhos' => 'id_anhos',
            'fecha_creacion' => 'fecha_creacion'
        )
         
           
        
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
       'CO_VIGENCIA_FUTURA' =>
        array(    
            'id_vigencia_futura,a' => array('!=' => array(-1)),
            'id_vigencia_futura,b' => array('=' => array('id_vigencia_futura')),
            'id_estudios_previos' => array('=' => array('id_estudios_previos')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_vigencia_futura'; //identificador de la tabla
    protected $id_names = array('id_vigencia_futura'); //llave primaria
    protected $field_names = array('id_estudios_previos','valor', 'fecha_aprobacion','no_aprobacion','plazo_final'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_VIGENCIA_FUTURA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_vigencia_futura'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
           
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        $id_estudios_previos = $request['id_estudios_previos'];
        $valor_aporte = $request['valor'];
        $sql = <<<EOD
        select valor from co_estudios_previos
                where id_estudios_previos = $id_estudios_previos and estado = 1
EOD;
        $records = CN_TABLE::executeSQL($sql);
        
        $valor = $records[0]['valor'];
        
        $sql = <<<EOD
        select nvl(sum(valor),0) as valor from co_cdps_ep
                where id_estudios_previos = $id_estudios_previos
EOD;
        $records = CN_TABLE::executeSQL($sql);
        
        $total_cdp = $records[0]['valor'];
        
        $sql = <<<EOD
        select nvl(sum(valor),0) as valor from co_aporte_externo
                where id_estudios_previos = $id_estudios_previos
EOD;
        $records = CN_TABLE::executeSQL($sql);
        
        $total_aportes = $records[0]['valor'];
        
        $sql = <<<EOD
        select nvl(sum(valor),0) as valor from co_vigencia_futura
                where id_estudios_previos = $id_estudios_previos
EOD;
        $records = CN_TABLE::executeSQL($sql);
        
        $total_vigencias = $records[0]['valor'];
        
        $total = $total_aportes + $total_cdp + $valor_aporte+$total_vigencias;
        
        if($total>$valor){
            
            $errors['mensaje'] = "El valor supera al valor Total del Proceso";
            $errors['servicio'] = "co_estudios_previos";
        }
        
        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    } 
}
